c     Removing trends and jumps
c     using binning or moving average
c
c     Input: trend.param
c            data file
c
c     Output: avgint.fname (binning case)
c             arma.fnam (moving average case)
c    
c     by Jozsef M. Benko at Konkoly Observatory, 2008
c
      program trend
      IMPLICIT REAL*8 (A-H,O-Z)
      real*8 mat,maf
      integer rgb
      character*80 fname,kiname,sor,sr,kimname
      character*1 szin,ss
      dimension hjd(500000),flux(500000)
      dimension hjdbe(500000),fluxbe(500000)
      dimension armaj(500000),armaf(500000),xa(10),ya(10)
      dimension x(500000),y(500000),aj(500000),af(500000)
      dimension sub(500000),sor(30),sube(500000),be(50,500000)

c     Size of the bins: dx
c     Boxcar functions width: csh

      n=1
      js=1

c     Reading the parmeters
      open(1,file='trend_rr.param')
        read(1,*)
        read(1,676)fname
        write(*,*)fname
        read(1,*)  
        read(1,*)ihjd,imag,isum
        read(1,*)
        read(1,*)dx
        read(1,*)
        read(1,*)csh
        read(1,*)
        read(1,*)ir
        read(1,*)
        read(1,*)sn,ise
        read(1,*)
        read(1,*)rgb
      close(1)
 676  format(a12)

c     Read observed data
      l=1
      open(1,file=fname)
      i=1
   19 read(1,777)sr
          ss=sr(1:1)
          sor(i)=sr
          if (ss.eq.'#') then
           i=i+1
           go to 19
          endif
      is=i-1
c      write(*,*)is 
      backspace(1)
    6    read(1,*,end=555)(be(ki,l), ki=1,isum)
         hjdbe(l)=be(ihjd,l)
         fluxbe(l)=be(imag,l)
c        write(*,*)l,hjdbe(l),fluxbe(l)
        if (l.ne.1) then 
          sub(l)=dabs(fluxbe(l)-fluxbe(l-1))
          if (ise.eq.1) sube(l)=sub(l)**2
        endif 
        l=l+1
      go to 6
  555 close(1)
  888 format(f13.8,f11.2)
  988 format(a80,a15,f11.2)
  989 format(50f17.8)
  889 format(f13.8,1x,f13.2)
  777 format(a80,a15)
  778 format(a80)
      sub(1)=0.d0
      l=l-1
      ll=l

c     Search for jumps
      if (ise.eq.1) then
       call moment(sube,l-1,ave,adev,sdev,var,skew,curt)
       sdev=dsqrt(ave)
      else
       call moment(sub,l-1,ave,adev,sdev,var,skew,curt)
      endif
c      write(*,*)ise, sdev

      hjd(1)=hjdbe(1)
      flux(1)=fluxbe(1)
      k=2
      m=2
      ik=1
    8 if ((sub(k).lt.sn*sdev).and.(k.le.ll)) then
         hjd(m)=hjdbe(k)
         flux(m)=fluxbe(k)
c         write(*,*)m,k
         k=k+1
         m=m+1
         go to 8 
      endif
      l=m-1

      nx=dint((hjd(l)-hjd(1))/dx)
      dx=(hjd(l)-hjd(1))/dble(nx)
      

      write(szin, '(I1)'), rgb

c     Binned light curve, nx = No. of bins       
      call binnel(hjd,flux,l,dx,x,y)

c     Linear interpolation
      if (ir.eq.1) then
      if (n.eq.1) then
       kiname="bin."//fname
       write(*,*)kiname
       open(15,file=kiname)
       write(15,*)'# Size of bins:',dx
       n=n+1
      endif
      do 150 mm=1,nx
       write(15,888)x(mm),y(mm)
  150 continue
      if (n.eq.2) then
       if (rgb.eq.0) then
        kiname="avgint."//fname
        kimname="mag."//fname
       else
         kiname=szin//".avgint."//fname
         kimname=szin//".mag."//fname
       endif
       write(*,*)kiname
       write(*,*)kimname
       open(13,file=kiname)
       open(14,file=kimname)
       do 233 mn=1,is
         write(13,*)sor(mn)
  233  continue
       write(13,*)'# Size of bins:',dx
       write(13,*)'# Factor of the sigma:',sn
       n=n+1
      endif
      do 251 i=1,l
       xx=hjd(i)
       call locate(x,nx,xx,jj) 
       xa(1)=x(jj)
       ya(1)=y(jj)
         xa(2)=x(jj+1)
         ya(2)=y(jj+1)
       call polint(xa,ya,2,xx,yy,dy)
       write(13,989)(be(m,ik), m=1,isum),flux(i)-yy
       dmagki=2.5d0*dlog10((be(imag,ik)-(flux(i)-yy))/be(imag,ik))
       write(14,989)be(ihjd,ik),dmagki
       ik=ik+1
  251 continue
      go to 152
      endif

      
c     Moving average
      if (ir.eq.2) then      
      ncs=dint(csh/dx)
      csh=dble(ncs)*dx
      
      j=1
      if (n.eq.1) then
       kiname="ma."//fname
       write(*,*)kiname
       open(16,file=kiname)
       write(16,*)'# Stepsize:',dx
       write(16,*)'# Boxcars width:',csh
       n=n+1
      endif
      mat=0.d0
      maf=0.d0
      do 77 i=1,ncs
        mat=mat+x(i)
        maf=maf+y(i)
  77  continue
      armaj(j)=mat
      armaf(j)=maf
      write(16,888)armaj(j)/dble(ncs),armaf(j)/dble(ncs)
      aj(j)=armaj(j)/dble(ncs)
      af(j)=armaf(j)/dble(ncs)

  55  if (j.le.(nx-ncs)) then 
        j=j+1     
        armaj(j)=armaj(j-1)-x(j-1)+x(ncs+j-1)
        armaf(j)=armaf(j-1)-y(j-1)+y(ncs+j-1)
        aj(j)=armaj(j)/dble(ncs)
        af(j)=armaf(j)/dble(ncs)
        write(16,888)armaj(j)/dble(ncs),armaf(j)/dble(ncs)
        go to 55
      endif

c     Linear interpolation
      if (n.eq.2) then
       if (rgb.eq.0) then
         kiname="arma."//fname
         kimname="mag."//fname
       else
         kiname=szin//".arma."//fname
         kimname=szin//".mag."//fname
       endif
       write(*,*)kiname
       write(*,*)kimname
       open(12,file=kiname)
       open(14,file=kimname)
       do 234 mn=1,is
         write(12,*)sor(mn)
  234  continue
       write(12,*)'# Stepsize:',dx
       write(12,*)'# Boxcars width:',csh
       write(12,*)'# Factor of the sigma:',sn
       n=n+1
      endif
      do 151 i=1,l
       xx=hjd(i)
       call locate(aj,j,xx,jj) 
       xa(1)=aj(jj)
       ya(1)=af(jj)
         xa(2)=aj(jj+1)
         ya(2)=af(jj+1)
       call polint(xa,ya,2,xx,yy,dy)
       write(12,989)(be(m,ik), m=1,isum),flux(i)-yy
       dmagki=2.5d0*dlog10((be(imag,ik)-(flux(i)-yy))/be(imag,ik))
       write(14,989)be(ihjd,ik),dmagki
       ik=ik+1
  151 continue
      endif

  152 continue
    
      if (k.le.ll) then
         hjd(1)=hjdbe(k)
         flux(1)=fluxbe(k)
         k=k+1
         m=2
         js=js+1
         go to 8
      endif

      close(14)
      close(13)
      close(12)
      close(16)
      close(15)
      write(*,*)'No. sections:', js
   
      end


      subroutine binnel(jbe,magbe,hossz,dx,jki,magki)
      IMPLICIT REAL*8 (a-h,o-z)
      real*8 magki,magbe,jbe,jki  
      dimension jbe(100000),jki(100000)
      dimension magbe(100000),magki(100000)
      integer hossz
         
c     ciklus  
      sumjd=0.d0
      sumfl=0.d0
      k=0
      j=1
      do 16 i=1,hossz 
        if (jbe(i).le.(jbe(1)+dble(j)*dx)) then
            sumjd=sumjd+jbe(i)
            sumfl=sumfl+magbe(i)
            k=k+1
        else
           jki(j)=sumjd/dble(k)
           magki(j)=sumfl/dble(k)
           sumjd=jbe(i)
           sumfl=magbe(i)
           j=j+1
           k=1
        endif
   16 continue
      jki(j)=sumjd/dble(k)
      magki(j)=sumfl/dble(k)      
         
      return
      end


      SUBROUTINE polint(xa,ya,n,x,y,dy)
      INTEGER n,NMAX   
      REAL*8 dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      REAL*8 den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den 
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1 
        endif
        y=y+dy
13    continue
      return  
      END


      SUBROUTINE locate(xx,n,x,j)
      INTEGER j,n
      REAL*8 x,xx(n)
      INTEGER jl,jm,ju
      jl=0
      ju=n+1
10    if(ju-jl.gt.1)then
        jm=(ju+jl)/2
        if((xx(n).ge.xx(1)).eqv.(x.ge.xx(jm)))then
          jl=jm
        else
          ju=jm
        endif
      goto 10
      endif
      if(x.eq.xx(1))then
        j=1
      else if(x.eq.xx(n))then
        j=n-1
      else
        j=jl
      endif
      return
      END

      SUBROUTINE moment(data,n,ave,adev,sdev,var,skew,curt)
      INTEGER n
      REAL*8 adev,ave,curt,sdev,skew,var,data(n)
      INTEGER j
      REAL*8 p,s,ep
      if(n.le.1)pause 'n must be at least 2 in moment'
      s=0.d0
      do 11 j=1,n
        s=s+data(j)
11    continue
      ave=s/dble(n)
      adev=0.d0
      var=0.d0
      skew=0.d0
      curt=0.d0
      ep=0.d0
      do 12 j=1,n
        s=data(j)-ave
        ep=ep+s
        adev=adev+dabs(s)
        p=s*s
        var=var+p
        p=p*s
        skew=skew+p
        p=p*s
        curt=curt+p
12    continue
      adev=adev/dble(n)
      var=(var-ep**2/dble(n))/dble(n-1)
      sdev=dsqrt(var)
      if(var.ne.0.d0)then
        skew=skew/(dble(n)*sdev**3)
        curt=curt/(dble(n)*var**2)-3.d0
      else
        pause 'no skew or kurtosis when zero variance in moment'
      endif
      return
      END
